import { CSSProperties, ReactNode } from 'react';
import { Position, TickLabelFormat } from '../../types';
export interface AxisProps {
    id?: string;
    position: Position;
    min?: number;
    max?: number;
    paddingStart?: number;
    paddingEnd?: number;
    flip?: boolean;
    scale?: 'linear' | 'log';
    /**
     * Hide all axis elements.
     */
    hidden?: boolean;
    /**
     * Hide the line.
     */
    hiddenLine?: boolean;
    lineStyle?: CSSProperties;
    label?: ReactNode;
    labelStyle?: CSSProperties;
    displayPrimaryGridLines?: boolean;
    primaryGridLineStyle?: CSSProperties;
    displaySecondaryGridLines?: boolean;
    secondaryGridLineStyle?: CSSProperties;
    hiddenTicks?: boolean;
    tickPosition?: 'inner' | 'outer' | 'center';
    tickLabelFormat?: TickLabelFormat;
    tickLabelStyle?: CSSProperties;
    primaryTickLength?: number;
    primaryTickStyle?: CSSProperties;
    secondaryTickLength?: number;
    secondaryTickStyle?: CSSProperties;
}
export declare function Axis({ id, position, min, max, paddingStart, paddingEnd, flip, scale, label, displayPrimaryGridLines, labelStyle, hidden, tickLabelStyle, tickLabelFormat, }: AxisProps): JSX.Element;
