import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { useContext } from 'react';
import { useBBoxObserver } from 'react-d3-utils';
import { bboxContext } from '../../bboxContext';
import HorizontalAxisGridLines from './HorizontalAxisGridLines';
import HorizontalAxisLabel from './HorizontalAxisLabel';
import HorizontalAxisLine from './HorizontalAxisLine';
import { Ticks } from './Ticks';
export default function HorizontalAxis(props) {
    const { hidden, plotWidth, plotHeight, displayPrimaryGridLines, label, labelStyle, axisRef, primaryTicks, position, tickLabelStyle, } = props;
    const isBottom = position === 'bottom';
    const transform = isBottom ? `translate(0, ${plotHeight})` : undefined;
    const ticks = useBBoxObserver();
    function getTickPosition(value) {
        return {
            line: {
                x1: value,
                x2: value,
                y2: !isBottom ? -5 : 5,
            },
            text: { x1: value, y1: isBottom ? 16 : -12 },
        };
    }
    const gridLinesElement = displayPrimaryGridLines ? (_jsx(HorizontalAxisGridLines, { position: position, plotHeight: plotHeight, primaryTicks: primaryTicks }, void 0)) : null;
    const primaryTicksElement = !hidden ? (_jsx(Ticks, { anchor: "middle", primaryTicks: primaryTicks, getPositions: getTickPosition, labelStyle: tickLabelStyle }, void 0)) : null;
    const axisLineElement = !hidden ? (_jsx(HorizontalAxisLine, { plotWidth: plotWidth }, void 0)) : null;
    const labelElement = !hidden && label ? (_jsx(HorizontalAxisLabel, { plotWidth: plotWidth, label: label, labelStyle: labelStyle, verticalAlign: isBottom ? 'start' : 'end' }, void 0)) : null;
    const bboxRef = useContext(bboxContext);
    return (_jsxs("g", { transform: transform, children: [gridLinesElement, _jsxs("g", { ref: bboxRef, children: [_jsx("g", { ref: ticks.ref, children: primaryTicksElement }, void 0), _jsx("g", { ref: axisRef, children: axisLineElement }, void 0), _jsx("g", { transform: `translate(0, ${ticks.height * (isBottom ? 1 : -1)})`, children: labelElement }, void 0)] }, void 0)] }, void 0));
}
//# sourceMappingURL=HorizontalAxis.js.map