import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
export function Ticks(props) {
    const { primaryTicks, getPositions, 
    // hiddenSecondaryTicks = false,
    ...otherProps } = props;
    // Primary Ticks
    let elements = primaryTicks.map((tick) => {
        const { line, text } = getPositions(tick.position);
        return (_jsx(Tick, { line: line, text: text, ...otherProps, children: tick.label }, tick.position));
    });
    /*if (!hiddenSecondaryTicks) {
      // generate secondaryTicks according to the density of primaryTicks
      const range = Math.abs(scale?.range()[1] - scale?.range()[0]) || 0;
      const mainTicksDensity = range / primaryTicks.length;
      const density = mainTicksDensity < 50 ? 5 : 10;
      let secTicks = scale?.ticks(primaryTicks.length * density) || [];
  
      // calculate middle tick position ([0,1]=> middle tick == 0.5)
      let middleTick = 0;
      let secTicksPerInterval = 0;
      if (primaryTicks.length > 1) {
        let i = 0;
        while (secTicks[i] < primaryTicks[1]) {
          while (secTicks[i] < primaryTicks[0]) {
            i++;
            middleTick++;
          }
          secTicksPerInterval++;
          i++;
        }
      }
      const middleTickEnabled =
        secTicksPerInterval % 2 === 0 && secTicksPerInterval > 0;
      middleTick = middleTick - secTicksPerInterval / 2 + 1;
  
      // add secondaryTicks to the elements array
      const secElements =
        secTicks.map((tick) => {
          middleTick--;
          let strokeHeight = middleTickEnabled && middleTick === 0 ? 1 : 0.6;
          // exclude the main ticks
          if (primaryTicks.includes(tick)) {
            middleTick = secTicksPerInterval / 2;
            return null;
          }
          const { line, text } = getPositions(scale(tick));
          return (
            <Tick
              key={tick}
              line={line}
              text={text}
              secondary
              strokeHeight={strokeHeight}
              {...otherProps}
            />
          );
        }) || [];
      elements = [...secElements, ...elements];
    }*/
    return _jsx(_Fragment, { children: elements }, void 0);
}
export function Tick(props) {
    const { line: { x1: lineX1 = 0, x2: lineX2 = 0, y1: lineY1 = 0, y2: lineY2 = 0 }, text: { x1: textX1 = 0, y1: textY1 = 0 }, children, strokeColor = 'black', strokeHeight = 1, anchor = 'end', secondary = false, labelStyle, } = props;
    return (_jsxs("g", { children: [_jsx("line", { x1: lineX1, x2: secondary && lineX1 !== lineX2 ? lineX2 * strokeHeight : lineX2, y1: lineY1, y2: secondary && lineY1 !== lineY2 ? lineY2 * strokeHeight : lineY2, stroke: strokeColor, strokeWidth: secondary ? 1 : 1.5 }, void 0), !secondary && (_jsx("text", { x: textX1, y: textY1, textAnchor: anchor, dominantBaseline: "middle", style: { userSelect: 'none', ...labelStyle }, children: children }, void 0))] }, void 0));
}
//# sourceMappingURL=Ticks.js.map