import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { useContext } from 'react';
import { useBBoxObserver } from 'react-d3-utils';
import { bboxContext } from '../../bboxContext';
import { Ticks } from './Ticks';
import VerticalAxisGridLines from './VerticalAxisGridLines';
import VerticalAxisLabel from './VerticalAxisLabel';
import VerticalAxisLine from './VerticalAxisLine';
export default function VerticalAxis(props) {
    const { hidden, plotWidth, plotHeight, displayPrimaryGridLines, label, labelStyle, axisRef, primaryTicks, position, tickLabelStyle, } = props;
    const isRight = position === 'right';
    const transform = isRight ? `translate(${plotWidth}, 0)` : undefined;
    const ticks = useBBoxObserver();
    function getTickPosition(value) {
        return {
            line: {
                y1: value,
                y2: value,
                x2: !isRight ? -5 : 5,
            },
            text: { y1: value, x1: isRight ? 10 : -10 },
        };
    }
    const gridLinesElement = displayPrimaryGridLines ? (_jsx(VerticalAxisGridLines, { position: position, plotWidth: plotWidth, primaryTicks: primaryTicks }, void 0)) : null;
    const primaryTicksElement = !hidden ? (_jsx(Ticks, { anchor: isRight ? 'start' : 'end', primaryTicks: primaryTicks, getPositions: getTickPosition, labelStyle: tickLabelStyle }, void 0)) : null;
    const axisLineElement = !hidden ? (_jsx(VerticalAxisLine, { plotHeight: plotHeight }, void 0)) : null;
    const labelElement = !hidden && label ? (_jsx(VerticalAxisLabel, { plotHeight: plotHeight, label: label, labelStyle: labelStyle, horizontalAlign: isRight ? 'start' : 'end' }, void 0)) : null;
    const bboxRef = useContext(bboxContext);
    return (_jsxs("g", { transform: transform, children: [gridLinesElement, _jsxs("g", { ref: bboxRef, children: [_jsx("g", { ref: ticks.ref, children: primaryTicksElement }, void 0), _jsx("g", { ref: axisRef, children: axisLineElement }, void 0), _jsx("g", { transform: `translate(${ticks.width * (isRight ? 1 : -1)}, 0)`, children: labelElement }, void 0)] }, void 0)] }, void 0));
}
//# sourceMappingURL=VerticalAxis.js.map