declare type NumberOrString = number | string;
interface UsePositionConfig {
    x: NumberOrString;
    y: NumberOrString;
}
export declare function usePosition(config: UsePositionConfig): {
    x: number;
    y: number;
};
interface UsePositionAndSizeConfig extends UsePositionConfig {
    width: NumberOrString;
    height: NumberOrString;
}
interface UseRectanglePositionConfig {
    x1: NumberOrString;
    y1: NumberOrString;
    x2: NumberOrString;
    y2: NumberOrString;
}
export declare function usePositionAndSize(config: UsePositionAndSizeConfig): {
    x: number;
    y: number;
    width: string | number;
    height: string | number;
};
export declare function useRectanglePosition(config: UseRectanglePositionConfig): {
    x: number;
    y: number;
    width: number;
    height: number;
};
interface UseEllipsePositionConfig {
    cx: NumberOrString;
    cy: NumberOrString;
    rx: NumberOrString;
    ry: NumberOrString;
}
export declare function useEllipsePosition(props: UseEllipsePositionConfig): {
    cx: number;
    cy: number;
    rx: string | number;
    ry: string | number;
};
export declare function usePointPosition(config: UsePositionConfig[]): string;
export {};
