import { CSSProperties } from 'react';
import { PlotAxisContext } from './plotContext';
import type { CSSFuncProps, SeriesPointError } from './types';
/**
 * Creates autoincremental values, generally for series.
 */
export declare function getNextId(): number;
/**
 * Validates that two positions are not orthogonal between them
 */
export declare function validatePosition(currPosition: string, position: string, id: string): void;
/**
 * Validates that two axes are orthogonal between them
 */
export declare function validateAxis(axisContext: Record<string, PlotAxisContext>, xKey: string, yKey: string): import("d3-scale").ScaleLinear<number, number, never>[];
/**
 * Checks the style added to a component and if is a function, gets the resulting value
 */
export declare function functionalStyle<T>(defaultStyle: CSSProperties, elementStyle: CSSFuncProps<T>, point: T, index: number, data: T[]): CSSProperties;
/**
 * validate series point Error
 */
export declare function validateSeriesPointError(error: SeriesPointError): SeriesPointError;
export declare function closestPoint<T, R>(data: T[], value: R, distanceFun: (a: T, b: R) => number): T;
