"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = require("react");
const react_d3_utils_1 = require("react-d3-utils");
const bboxContext_1 = require("../../bboxContext");
const HorizontalAxisGridLines_1 = __importDefault(require("./HorizontalAxisGridLines"));
const HorizontalAxisLabel_1 = __importDefault(require("./HorizontalAxisLabel"));
const HorizontalAxisLine_1 = __importDefault(require("./HorizontalAxisLine"));
const Ticks_1 = require("./Ticks");
function HorizontalAxis(props) {
    const { hidden, plotWidth, plotHeight, displayPrimaryGridLines, label, labelStyle, axisRef, primaryTicks, position, tickLabelStyle, } = props;
    const isBottom = position === 'bottom';
    const transform = isBottom ? `translate(0, ${plotHeight})` : undefined;
    const ticks = (0, react_d3_utils_1.useBBoxObserver)();
    function getTickPosition(value) {
        return {
            line: {
                x1: value,
                x2: value,
                y2: !isBottom ? -5 : 5,
            },
            text: { x1: value, y1: isBottom ? 16 : -12 },
        };
    }
    const gridLinesElement = displayPrimaryGridLines ? ((0, jsx_runtime_1.jsx)(HorizontalAxisGridLines_1.default, { position: position, plotHeight: plotHeight, primaryTicks: primaryTicks }, void 0)) : null;
    const primaryTicksElement = !hidden ? ((0, jsx_runtime_1.jsx)(Ticks_1.Ticks, { anchor: "middle", primaryTicks: primaryTicks, getPositions: getTickPosition, labelStyle: tickLabelStyle }, void 0)) : null;
    const axisLineElement = !hidden ? ((0, jsx_runtime_1.jsx)(HorizontalAxisLine_1.default, { plotWidth: plotWidth }, void 0)) : null;
    const labelElement = !hidden && label ? ((0, jsx_runtime_1.jsx)(HorizontalAxisLabel_1.default, { plotWidth: plotWidth, label: label, labelStyle: labelStyle, verticalAlign: isBottom ? 'start' : 'end' }, void 0)) : null;
    const bboxRef = (0, react_1.useContext)(bboxContext_1.bboxContext);
    return ((0, jsx_runtime_1.jsxs)("g", { transform: transform, children: [gridLinesElement, (0, jsx_runtime_1.jsxs)("g", { ref: bboxRef, children: [(0, jsx_runtime_1.jsx)("g", { ref: ticks.ref, children: primaryTicksElement }, void 0), (0, jsx_runtime_1.jsx)("g", { ref: axisRef, children: axisLineElement }, void 0), (0, jsx_runtime_1.jsx)("g", { transform: `translate(0, ${ticks.height * (isBottom ? 1 : -1)})`, children: labelElement }, void 0)] }, void 0)] }, void 0));
}
exports.default = HorizontalAxis;
