"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = require("react");
const react_d3_utils_1 = require("react-d3-utils");
const bboxContext_1 = require("../../bboxContext");
const Ticks_1 = require("./Ticks");
const VerticalAxisGridLines_1 = __importDefault(require("./VerticalAxisGridLines"));
const VerticalAxisLabel_1 = __importDefault(require("./VerticalAxisLabel"));
const VerticalAxisLine_1 = __importDefault(require("./VerticalAxisLine"));
function VerticalAxis(props) {
    const { hidden, plotWidth, plotHeight, displayPrimaryGridLines, label, labelStyle, axisRef, primaryTicks, position, tickLabelStyle, } = props;
    const isRight = position === 'right';
    const transform = isRight ? `translate(${plotWidth}, 0)` : undefined;
    const ticks = (0, react_d3_utils_1.useBBoxObserver)();
    function getTickPosition(value) {
        return {
            line: {
                y1: value,
                y2: value,
                x2: !isRight ? -5 : 5,
            },
            text: { y1: value, x1: isRight ? 10 : -10 },
        };
    }
    const gridLinesElement = displayPrimaryGridLines ? ((0, jsx_runtime_1.jsx)(VerticalAxisGridLines_1.default, { position: position, plotWidth: plotWidth, primaryTicks: primaryTicks }, void 0)) : null;
    const primaryTicksElement = !hidden ? ((0, jsx_runtime_1.jsx)(Ticks_1.Ticks, { anchor: isRight ? 'start' : 'end', primaryTicks: primaryTicks, getPositions: getTickPosition, labelStyle: tickLabelStyle }, void 0)) : null;
    const axisLineElement = !hidden ? ((0, jsx_runtime_1.jsx)(VerticalAxisLine_1.default, { plotHeight: plotHeight }, void 0)) : null;
    const labelElement = !hidden && label ? ((0, jsx_runtime_1.jsx)(VerticalAxisLabel_1.default, { plotHeight: plotHeight, label: label, labelStyle: labelStyle, horizontalAlign: isRight ? 'start' : 'end' }, void 0)) : null;
    const bboxRef = (0, react_1.useContext)(bboxContext_1.bboxContext);
    return ((0, jsx_runtime_1.jsxs)("g", { transform: transform, children: [gridLinesElement, (0, jsx_runtime_1.jsxs)("g", { ref: bboxRef, children: [(0, jsx_runtime_1.jsx)("g", { ref: ticks.ref, children: primaryTicksElement }, void 0), (0, jsx_runtime_1.jsx)("g", { ref: axisRef, children: axisLineElement }, void 0), (0, jsx_runtime_1.jsx)("g", { transform: `translate(${ticks.width * (isRight ? 1 : -1)}, 0)`, children: labelElement }, void 0)] }, void 0)] }, void 0));
}
exports.default = VerticalAxis;
